;Copyright (C) 2004-2006 John T. Haller

;Website: http://PortableApps.com/PortableThunderbird

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

!define FULLNAME "AbiWord Portable"
!define NAME "AbiWordPortable"
!define APP "AbiWord"
!define VER "1.2.2.0"
!define WEBSITE "PortableApps.com/AbiWordPortable"
!define DEFAULTEXE "AbiWord.exe"
!define DEFAULTAPPDIR "AbiSuite2\AbiWord\bin"
!define DEFAULTSETTINGSPATH "settings"
!define DEFAULTSETTINGSFILE "AbiWord.profile"

;=== Program Details
Name "${FULLNAME}"
OutFile "${NAME}.exe"
Caption "${FULLNAME} | PortableApps.com"
VIProductVersion "${VER}"
VIAddVersionKey ProductName "${FULLNAME}"
VIAddVersionKey Comments "Allows ${APP} to be run from a removable drive.  For additional details, visit ${WEBSITE}"
VIAddVersionKey CompanyName "PortableApps.com (John T. Haller)"
VIAddVersionKey LegalCopyright "John T. Haller"
VIAddVersionKey FileDescription "${FULLNAME}"
VIAddVersionKey FileVersion "${VER}"
VIAddVersionKey ProductVersion "${VER}"
VIAddVersionKey InternalName "${FULLNAME}"
VIAddVersionKey LegalTrademarks "AbiWord is a trademark of Dom Lachowicz.  PortableApps.com is a trademark of Rare Ideas, LLC."
VIAddVersionKey OriginalFilename "${NAME}.exe"
;VIAddVersionKey PrivateBuild ""
;VIAddVersionKey SpecialBuild ""

;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True
RequestExecutionLevel user

;=== Include
!include "Registry.nsh"
!include "GetParameters.nsh"

;=== Program Icon
Icon "${NAME}.ico"

Var PROGRAMDIRECTORY
Var SETTINGSDIRECTORY
Var SETTINGSFILE
Var ADDITIONALPARAMETERS
Var REGISTRYDIRECTORY
Var EXECSTRING
Var PROGRAMEXECUTABLE
Var INIPATH
Var DISABLESPLASHSCREEN
Var ISDEFAULTDIRECTORY
Var TEMPPATH
Var SECONDARYLAUNCH
Var USERTYPE
Var USERPROFILEPATH


Section "Main"
	ReadEnvStr $USERPROFILEPATH "USERPROFILE"

	;=== Find the INI file, if there is one
		IfFileExists "$EXEDIR\${NAME}.ini" "" CheckSubINI
			StrCpy "$INIPATH" "$EXEDIR\"
			Goto ReadINI

	CheckSubINI:
		IfFileExists "$EXEDIR\${NAME}\${NAME}.ini" "" CheckSubSubINI
			StrCpy "$INIPATH" "$EXEDIR\${NAME}\"
			Goto ReadINI

	CheckSubSubINI:
		IfFileExists "$EXEDIR\PortableApps\${NAME}\${NAME}.ini" "" CheckPortableAppsINI
			StrCpy "$INIPATH" "$EXEDIR\PortableApps\${NAME}\"
			Goto ReadINI

	CheckPortableAppsINI:
		IfFileExists "$EXEDIR\Data\${NAME}\${NAME}.ini" ""  NoINI
			StrCpy "$INIPATH" "$EXEDIR\Data\${NAME}\"
			Goto ReadINI

	ReadINI:
		;=== Read the parameters from the INI file
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Directory"
		StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SettingsDirectory"
		StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\$0"
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "SettingsFile"
		StrCpy "$SETTINGSFILE" "$0"

		;=== Check that the above required parameters are present
		IfErrors NoINI

		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "AdditionalParameters"
		StrCpy "$ADDITIONALPARAMETERS" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APP}Executable"
		StrCpy "$PROGRAMEXECUTABLE" $0
		ReadINIStr $0 "$INIPATH\${NAME}.ini" "${NAME}" "DisableSplashScreen"
		StrCpy "$DISABLESPLASHSCREEN" $0

	;CleanUpAnyErrors:
		;=== Any missing unrequired INI entries will be an empty string, ignore associated errors
		ClearErrors

		;=== Correct PROGRAMEXECUTABLE if blank
		StrCmp $PROGRAMEXECUTABLE "" "" EndINI
			StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
			Goto EndINI

	NoINI:
		;=== No INI file, so we'll use the defaults
		StrCpy "$ADDITIONALPARAMETERS" ""
		StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
		StrCpy "$DISABLESPLASHSCREEN" "false"
		StrCpy "$SETTINGSFILE" "${DEFAULTSETTINGSFILE}"

		IfFileExists "$EXEDIR\App\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableProgramDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\App\${DEFAULTAPPDIR}"
			StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\Data\${DEFAULTSETTINGSPATH}"
			StrCpy "$ISDEFAULTDIRECTORY" "true"
			GoTo EndINI

		CheckPortableProgramDIR:
			IfFileExists "$EXEDIR\${NAME}\App\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\${NAME}\App\${DEFAULTAPPDIR}"
			StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\${NAME}\Data\${DEFAULTSETTINGSPATH}"
			GoTo EndINI

		CheckPortableAppsDIR:
			IfFileExists "$EXEDIR\PortableApps\${NAME}\App\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" CheckPortableAppsSplitDIR
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\PortableApps\${NAME}\App\${DEFAULTAPPDIR}"
			StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\PortableApps\${NAME}\Data\${DEFAULTSETTINGSPATH}"
			GoTo EndINI

		CheckPortableAppsSplitDIR:
			IfFileExists "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}\${DEFAULTEXE}" "" NoProgramEXE
			StrCpy "$PROGRAMDIRECTORY" "$EXEDIR\Apps\${NAME}\${DEFAULTAPPDIR}"
			StrCpy "$SETTINGSDIRECTORY" "$EXEDIR\Data\${NAME}\${DEFAULTSETTINGSPATH}"
	
	EndINI:
		IfFileExists "$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" FoundProgramEXE

	NoProgramEXE:
		;=== Program executable not where expected
		MessageBox MB_OK|MB_ICONEXCLAMATION `$PROGRAMEXECUTABLE was not found.  Please check your configuration`
		Abort
		
	FoundProgramEXE:
		;=== Check if already running
		FindProcDLL::FindProc "$PROGRAMEXECUTABLE"
		Pop $R0                     
		StrCmp $R0 "1" "" CheckForSettings
			StrCpy $SECONDARYLAUNCH "true"
	
	CheckForSettings:
		IfFileExists "$SETTINGSDIRECTORY\$SETTINGSFILE" SettingsFound
		;=== No settings found
		StrCmp $ISDEFAULTDIRECTORY "true" CopyDefaultSettings
		CreateDirectory $SETTINGSDIRECTORY
		Goto SettingsFound
	
	CopyDefaultSettings:
		CreateDirectory "$EXEDIR\Data"
		CreateDirectory "$EXEDIR\Data\settings"
		CopyFiles /SILENT $EXEDIR\App\DefaultData\settings\*.* $EXEDIR\Data\settings
		GoTo SettingsFound

	SettingsFound:
		;=== Figure out the temp registry store
		ReadEnvStr $R0 "TEMP"
		StrCpy $TEMPPATH $R0
		StrCpy "$REGISTRYDIRECTORY" "$TEMPPATH\${NAME}\registry"


	;DisplaySplash:
		StrCmp $DISABLESPLASHSCREEN "true" GetPassedParameters
		StrCmp $SECONDARYLAUNCH "true" GetPassedParameters
			;=== Show the splash screen before processing the files
			InitPluginsDir
			File /oname=$PLUGINSDIR\splash.jpg "${NAME}.jpg"	
			newadvsplash::show /NOUNLOAD 2000 200 0 -1 /L $PLUGINSDIR\splash.jpg

	GetPassedParameters:
		;=== Get any passed parameters
		Call GetParameters
		Pop $0
		StrCmp "'$0'" "''" "" LaunchProgramParameters

		;=== No parameters
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" -u "$SETTINGSDIRECTORY\$SETTINGSFILE"`
		Goto AdditionalParameters

	LaunchProgramParameters:
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\$PROGRAMEXECUTABLE" -u "$SETTINGSDIRECTORY\$SETTINGSFILE" $0`

	AdditionalParameters:
		StrCmp $ADDITIONALPARAMETERS "" PrepareCustomDictionary

		;=== Additional Parameters
		StrCpy $EXECSTRING `$EXECSTRING $ADDITIONALPARAMETERS`
		
	PrepareCustomDictionary:
		StrCmp $SECONDARYLAUNCH "true" StartProgramAndExit
		CreateDirectory "$USERPROFILEPATH\AbiSuite\"
		Rename "$USERPROFILEPATH\AbiSuite\custom.dic" "$USERPROFILEPATH\AbiSuite\customlocal.dic"
		CopyFiles "$SETTINGSDIRECTORY\custom.dic" "$USERPROFILEPATH\AbiSuite\"

	;LaunchNow:
		;=== Check for registry permissions
		UserInfo::GetAccountType
		Pop $0
		StrCpy $USERTYPE $0
		StrCmp $USERTYPE "Guest" StartProgramNow
		StrCmp $USERTYPE "User" StartProgramNow
		
		CreateDirectory "$REGISTRYDIRECTORY"
		${registry::SaveKey} "HKEY_CLASSES_ROOT\.abw" "$REGISTRYDIRECTORY\abiword1.reg" "/G=1" $R0
		${registry::SaveKey} "HKEY_CLASSES_ROOT\.zabw" "$REGISTRYDIRECTORY\abiword2.reg" "/G=1" $R0
		${registry::SaveKey} "HKEY_CLASSES_ROOT\AbiSuite.AbiWord" "$REGISTRYDIRECTORY\abiword3.reg" "/G=1" $R0
		${registry::SaveKey} "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.abw" "$REGISTRYDIRECTORY\abiword4.reg" "/G=1" $R0
		${registry::SaveKey} "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.zabw" "$REGISTRYDIRECTORY\abiword5.reg" "/G=1" $R0
		${registry::SaveKey} "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\AbiSuite.AbiWord" "$REGISTRYDIRECTORY\abiword6.reg" "/G=1" $R0

	StartProgramNow:
		ExecWait $EXECSTRING
		
	CheckRunning:
		Sleep 2000
		FindProcDLL::FindProc "$PROGRAMEXECUTABLE"
		Pop $R0                     
		StrCmp $R0 "1" CheckRunning TheEnd
	
	StartProgramAndExit:
		Exec $EXECSTRING
		Goto CloseRegistry

	TheEnd:
		;=== Cleanup the custom dictionary
		CopyFiles "$USERPROFILEPATH\AbiSuite\custom.dic" "$SETTINGSDIRECTORY\"
		Delete "$USERPROFILEPATH\AbiSuite\custom.dic"
		Rename "$USERPROFILEPATH\AbiSuite\customlocal.dic" "$USERPROFILEPATH\AbiSuite\custom.dic"
		RMDir "$USERPROFILEPATH\AbiSuite\" ;=== Will only delete if empty (no /r switch)
	
		;=== Restore registry keys
		StrCmp $USERTYPE "Guest" EndWithoutRegRestore
		StrCmp $USERTYPE "User" EndWithoutRegRestore
		${registry::DeleteKey} "HKEY_CLASSES_ROOT\.abw" $R0
		${registry::RestoreKey} "$REGISTRYDIRECTORY\abiword1.reg" $R0
		${registry::DeleteKey} "HKEY_CLASSES_ROOT\.zabw" $R0
		${registry::RestoreKey} "$REGISTRYDIRECTORY\abiword2.reg" $R0
		${registry::DeleteKey} "HKEY_CLASSES_ROOT\AbiSuite.AbiWord" $R0
		${registry::RestoreKey} "$REGISTRYDIRECTORY\abiword3.reg" $R0
		${registry::DeleteKey} "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.abw" $R0
		${registry::RestoreKey} "$REGISTRYDIRECTORY\abiword4.reg" $R0
		${registry::DeleteKey} "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.abw" $R0
		${registry::RestoreKey} "$REGISTRYDIRECTORY\abiword5.reg" $R0
		${registry::DeleteKey} "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.abw" $R0
		${registry::RestoreKey} "$REGISTRYDIRECTORY\abiword6.reg" $R0
	
	EndWithoutRegRestore:
		StrCmp $DISABLESPLASHSCREEN "true" CleanupRunLocally
			Sleep 2000
			newadvsplash::stop

	CleanupRunLocally:
		${registry::Unload}
		RMDir /r "$TEMPPATH\${NAME}\"
		Goto EndOfLauncher
		
	CloseRegistry:
		${registry::Unload}
	
	EndOfLauncher:
SectionEnd